Summary:	Linux WPA Supplicant (IEEE 802.1X, WPA, WPA2, RSN, IEEE 802.11i)
Name:		wpa_supplicant
Version:	2.10
Release:	%mkrel 2
License:	GPL
Group:		Communications
URL:		https://w1.fi/releases/
Source0:    https://w1.fi/releases/%{name}-%{version}.tar.gz
Source2:    icons.tar
Source3:	wpa_supplicant.sysconfig
Source4:	wpa_supplicant.logrotate
Source5:	org.pclinuxos.wpa_gui.policy
Source6:	wpa.init

Patch0:     wpa_supplicant-2.10-pclos-defconfig.patch
Patch1:     wpa_supplicant-flush-debug-output.patch
Patch2:     wpa_supplicant-sigusr1-changes-debuglevel.patch
Patch3:     wpa_supplicant-alloc_size.patch
Patch5:     wpa_supplicant-dump-certificate-as-PEM-in-debug-mode.diff
Patch6:     wpa_supplicant-2.10-no-inkscape.patch
Patch7:     Revert-DBus-Add-sae-to-interface-key_mgmt-capabilities.patch
Patch9:     wpa_supplicant-file-args.patch
Patch13:    wpa_supplicant-2.2-quiet-scan-results-message.patch
Patch50:    wpa_supplicant-icons.patch
Patch51:    wpa_supplicant-assoc-timeout.patch
Patch54:    wpa_supplicant-gui-pclinux-qt4.patch


BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(libpcsclite)
BuildRequires:	readline-devel
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	doxygen
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	libnl3-devel
BuildRequires:	docbook-utils

%description
wpa_supplicant is a WPA Supplicant for Linux, BSD and Windows with
support for WPA and WPA2 (IEEE 802.11i / RSN). Supplicant is the IEEE
802.1X/WPA component that is used in the client stations. It
implements key negotiation with a WPA Authenticator and it controls
the roaming and IEEE 802.11 authentication/association of the wlan
driver.

wpa_supplicant is designed to be a "daemon" program that runs in the
background and acts as the backend component controlling the wireless
connection. wpa_supplicant supports separate frontend programs and an
example text-based frontend, wpa_cli, is included with wpa_supplicant.

Supported WPA/IEEE 802.11i features:
    * WPA-PSK ("WPA-Personal")
    * WPA with EAP (e.g., with RADIUS authentication server)
      ("WPA-Enterprise")
    * key management for CCMP, TKIP, WEP104, WEP40
    * WPA and full IEEE 802.11i/RSN/WPA2
    * RSN: PMKSA caching, pre-authentication

See the project web site or the eap_testing.txt file for a complete
list of supported EAP methods (IEEE 802.1X Supplicant), supported
drivers and interoperability testing.

%package gui
Group: System/Networking
Summary: Graphical tool for wpa_supplicant
Obsoletes: wpa_gui
Conflicts: wpa_supplicant < 1.0

%description gui
wpa_gui is a QT frontend for wpa_supplicant.
wpa_supplicant is a WPA Supplicant for Linux, BSD and Windows with
support for WPA and WPA2 (IEEE 802.11i / RSN).

%prep
%setup -q
cp %name/defconfig %name/.config
# use prebuilt icons from now
tar xf %SOURCE2 -C wpa_supplicant/wpa_gui-qt4
sed -ri 's,^all:.+$,all:,' wpa_supplicant/wpa_gui-qt4/icons/Makefile

%apply_patches

pushd wpa_supplicant
cp %{SOURCE6} wpa.init
# (blino) comment all "network = { }" blocks
perl -pi -e '$_ = "# $_" if /^\s*network\s*=\s*{/ .. /^\s*}/' wpa_supplicant.conf
popd

%build
%setup_compile_flags
make -C %name
make -C %name/doc/docbook man
pushd wpa_supplicant
%make_build eapol_test 
popd
%install

install -D -m 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -D -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -D -m 0644 %{SOURCE5} %{buildroot}%{_datadir}/polkit-1/actions/org.pclinuxos.wpa_gui.policy

pushd wpa_supplicant

# binaries
install -d %{buildroot}%{_sbindir}
install -m 755 wpa_supplicant %{buildroot}/%{_sbindir}
install -m 755 wpa_cli %{buildroot}/%{_sbindir}
install -m 755 wpa_passphrase %{buildroot}/%{_sbindir}
install -m 755 eapol_test %{buildroot}%{_sbindir}


# config
install -d -m 755 %{buildroot}%{_sysconfdir}
install -m 600 wpa_supplicant.conf %{buildroot}%{_sysconfdir}/wpa_supplicant.conf

# init
install -d %{buildroot}%{_initrddir}
install -m0755 wpa.init %{buildroot}%{_initrddir}/wpa

# dbus
install -d %{buildroot}%{_sysconfdir}/dbus-1/system.d
install -d %{buildroot}%{_datadir}/dbus-1/system-services
install -m 644 dbus/dbus-wpa_supplicant.conf \
    %{buildroot}%{_sysconfdir}/dbus-1/system.d/wpa_supplicant.conf

install -m 0644 dbus/fi.w1.wpa_supplicant1.service \
     %{buildroot}%{_datadir}/dbus-1/system-services

# man
install -d -m 755 %{buildroot}%{_mandir}/man{5,8}
install -m 644 doc/docbook/*.8 %{buildroot}%{_mandir}/man8
install -m 644 doc/docbook/*.5 %{buildroot}%{_mandir}/man5

popd

mkdir -p %buildroot%_iconsdir
tar c -C %name/wpa_gui-qt4/icons hicolor |tar x -C %buildroot%_iconsdir
install -pm0755 -D %name/wpa_gui-qt4/wpa_gui %buildroot%_bindir/wpa_gui

mkdir -p %{buildroot}%{_datadir}/applications
%__cat <<EOF > %{buildroot}%{_datadir}/applications/%{name}.desktop
[Desktop Entry]
Encoding=UTF-8
Name=wpa_gui
Comment=Graphical user interface for wpa_supplicant
Exec=pkexec /usr/bin/wpa_gui
Icon=wpa_gui
GenericName=wpa_supplicant user interface
Terminal=false
Type=Application
Categories=System;Settings;X-MandrivaLinux-System-Configuration-Hardware;
X-Desktop-File-Install-Version=0.21
EOF

%post
%_post_service wpa 
/sbin/service wpa check >/dev/null 2>&1
/sbin/chkconfig wpa reset >/dev/null 2>&1
/sbin/service wpa restart >/dev/null 2>&1

%preun
%_preun_service wpa

%clean
rm -rf %{buildroot}

%files
%doc wpa_supplicant/ChangeLog wpa_supplicant/README wpa_supplicant/eap_testing.txt wpa_supplicant/todo.txt
%doc wpa_supplicant/examples/*.conf
%attr(0600,root,daemon) %config(noreplace) %{_sysconfdir}/wpa_supplicant.conf
%attr(0755,root,root) %{_initrddir}/wpa
%config(noreplace) %{_sysconfdir}/logrotate.d/wpa_supplicant
%config(noreplace) %{_sysconfdir}/sysconfig/wpa_supplicant
%{_sbindir}/wpa_cli
%{_sbindir}/wpa_passphrase
%{_sbindir}/wpa_supplicant
%{_sbindir}/eapol_test
%{_sysconfdir}/dbus-1/system.d/wpa_supplicant.conf
#%{_datadir}/dbus-1/system-services/fi.epitest.hostap.WPASupplicant.service
%{_datadir}/dbus-1/system-services/fi.w1.wpa_supplicant1.service
%{_mandir}/man8/*
%{_mandir}/man5/*

%exclude %{_mandir}/man8/wpa_gui.8.*
%files gui
%{_bindir}/wpa_gui
%{_datadir}/applications/%{name}.desktop
%{_datadir}/polkit-1/actions/org.pclinuxos.wpa_gui.policy
%{_mandir}/man8/wpa_gui.8.*
%{_iconsdir}/hicolor/*/*/*.png

%changelog
* Wed Feb 08 2022 tex - 2.10-2pclos2022
- add docbook-utils

* Wed Feb 08 2022 yodelu - 2.10-1pclos2022
- new ver
- update patches

* Mon Jun 28 2021 yodelu - 2.9-6pclos2021
- minor fixes in wpa.init

* Mon Jun 28 2021 yodelu - 2.9-6pclos2021
- minor fixes in wpa.init

* Thu Jun 24 2021 yodelu - 2.9-5pclos2021
- add sysV service

* Wed Jun 23 2021 yodelu - 2.9-4pclos2021
- enable OWS
- fix wpa_gui 
- clean spec

* Fri Mar 13 2020 onkelho <oh.quait at gmail.com> - 2.9-3pclos2020
- rebuild, add polkit-1/action...policy and .desktop

* Wed Mar 11 2020 onkelho <oh.quait at gmail.com> - 2.9-2pclos2020
- rebuild, remove tempfiles systemd-stuff

* Wed Mar 11 2020 onkelho <oh.quait at gmail.com> - 2.9-1pclos2020
- new ver-rel 2019-08-07 - v2.9
- SAE changes
- - disable use of groups using Brainpool curves
- - improved protection against side channel attacks
	  [https://w1.fi/security/2019-6/]
- EAP-pwd changes
- - disable use of groups using Brainpool curves
- - allow the set of groups to be configured (eap_pwd_groups)
- - improved protection against side channel attacks
	  [https://w1.fi/security/2019-6/]
- fixed FT-EAP initial mobility domain association using PMKSA caching
- - (disabled by default for backwards compatibility; can be enabled
- - with ft_eap_pmksa_caching=1)
- fixed a regression in OpenSSL 1.1+ engine loading
- added validation of RSNE in (Re)Association Response frames
- fixed DPP bootstrapping URI parser of channel list
- extended EAP-SIM/AKA fast re-authentication to allow use with FILS
- extended ca_cert_blob to support PEM format
- improved robustness of P2P Action frame scheduling
- added support for EAP-SIM/AKA using anonymous@realm identity
- fixed Hotspot 2.0 credential selection based on roaming consortium
- - to ignore credentials without a specific EAP method
- added experimental support for EAP-TEAP peer (RFC 7170)
- added experimental support for EAP-TLS peer with TLS v1.3
- fixed a regression in WMM parameter configuration for a TDLS peer
- fixed a regression in operation with drivers that offload 802.1X
- - 4-way handshake
- fixed an ECDH operation corner case with OpenSSL

* Fri May 31 2019 onkelho <oh.quait at gmail.com> - 2.8-1pclos2019
- new ver-rel -- 2019-04-21 - v2.8
	* SAE changes
	  - added support for SAE Password Identifier
	  - changed default configuration to enable only groups 19, 20, 21
	    (i.e., disable groups 25 and 26) and disable all unsuitable groups
	    completely based on REVmd changes
	  - do not regenerate PWE unnecessarily when the AP uses the
	    anti-clogging token mechanisms
	  - fixed some association cases where both SAE and FT-SAE were enabled
	    on both the station and the selected AP
	  - started to prefer FT-SAE over SAE AKM if both are enabled
	  - started to prefer FT-SAE over FT-PSK if both are enabled
	  - fixed FT-SAE when SAE PMKSA caching is used
	  - reject use of unsuitable groups based on new implementation guidance
	    in REVmd (allow only FFC groups with prime >= 3072 bits and ECC
	    groups with prime >= 256)
	  - minimize timing and memory use differences in PWE derivation
	    [https://w1.fi/security/2019-1/] (CVE-2019-9494)
	* EAP-pwd changes
	  - minimize timing and memory use differences in PWE derivation
	    [https://w1.fi/security/2019-2/] (CVE-2019-9495)
	  - verify server scalar/element
	    [https://w1.fi/security/2019-4/] (CVE-2019-9499)
	  - fix message reassembly issue with unexpected fragment
	    [https://w1.fi/security/2019-5/]
	  - enforce rand,mask generation rules more strictly
	  - fix a memory leak in PWE derivation
	  - disallow ECC groups with a prime under 256 bits (groups 25, 26, and
	    27)
	* fixed CONFIG_IEEE80211R=y (FT) build without CONFIG_FILS=y
	* Hotspot 2.0 changes
	  - do not indicate release number that is higher than the one
	    AP supports
	  - added support for release number 3
	  - enable PMF automatically for network profiles created from
	    credentials
	* fixed OWE network profile saving
	* fixed DPP network profile saving
	* added support for RSN operating channel validation
	  (CONFIG_OCV=y and network profile parameter ocv=1)
	* added Multi-AP backhaul STA support
	* fixed build with LibreSSL
	* number of MKA/MACsec fixes and extensions
	* extended domain_match and domain_suffix_match to allow list of values
	* fixed dNSName matching in domain_match and domain_suffix_match when
	  using wolfSSL
	* started to prefer FT-EAP-SHA384 over WPA-EAP-SUITE-B-192 AKM if both
	  are enabled
	* extended nl80211 Connect and external authentication to support
	  SAE, FT-SAE, FT-EAP-SHA384
	* fixed KEK2 derivation for FILS+FT
	* extended client_cert file to allow loading of a chain of PEM
	  encoded certificates
	* extended beacon reporting functionality
	* extended D-Bus interface with number of new properties
	* fixed a regression in FT-over-DS with mac80211-based drivers
	* OpenSSL: allow systemwide policies to be overridden
	* extended driver flags indication for separate 802.1X and PSK
	  4-way handshake offload capability
	* added support for random P2P Device/Interface Address use
	* extended PEAP to derive EMSK to enable use with ERP/FILS
	* extended WPS to allow SAE configuration to be added automatically
	  for PSK (wps_cred_add_sae=1)
	* removed support for the old D-Bus interface (CONFIG_CTRL_IFACE_DBUS)
	* extended domain_match and domain_suffix_match to allow list of values
	* added a RSN workaround for misbehaving PMF APs that advertise
	  IGTK/BIP KeyID using incorrect byte order
	* fixed PTK rekeying with FILS and FT

* Wed Mar 21 2018  onkelho <oh.quait at gmail.com> 2.6-3pclos2018
- test new git-version

* Sun Nov 05 2017 bb2 <bb2> - 2.6-2pclos2017
- rebuild against updates

* Tue Oct 17 2017 bb2 <bb2> - 2.6-1pclos2017
- new version plus security patches
